var SDRequest = false;
var SniffedData = "";

document.onkeypress = getKeypress;      //Attach keypress handler to keypress events
setInterval('periodicUpdate()', 1000);  //Run periodicUpdate() every 5 seconds

//Keypress handler
function getKeypress(e){
  var evtobj=window.event ? event : e; //distinguish between IE's explicit event object (window.event) and Firefox's implicit.
  var unicode=evtobj.charCode ? evtobj.charCode : evtobj.keyCode

  var keypressed=String.fromCharCode(unicode);

  switch(keypressed){
    case "r":
      resetModified();
      break;
    default:
  }
}

//Periodic update function
function periodicUpdate(){
  requestSD();
  //resetModified();
}

//Reset all modified
function resetModified()
{
  var Tags = document.getElementsByTagName('*');
  for(var i=0; i<Tags.length; i++){
    if(Tags[i].className=="datamodified"){
      try {
        Tags[i].className="data";
      } catch (e) {
        alert(e.message);
      }
    }
  }
}

function requestSD(){
  parameters = '';
  url='./getsniffcandata.php';
  SDRequest = GetXMLHttpObject();

  if(SDRequest == null){
    alert("Failed to use AJAX!");
    return false;
  }

  if(SDRequest.overrideMimeType){
    SDRequest.overrideMimeType('text/xml');
  }

  //Send the request
  SDRequest.onreadystatechange = processSD;
  SDRequest.open('GET', url + parameters, true);
  SDRequest.send(null);
}

function drawsniffdata(CanID, Data, TimeStamp){

  try {
    for(var i=0; i<8; i++){
      try {
        var Value = Data.substr(i*2,2);
      } catch (e) {
        var Value = '-';
      }
      if(document.getElementById(CanID+'-'+i).className == "data"){
        if(document.getElementById(CanID+'-'+i).innerHTML != Value){
          document.getElementById(CanID+'-'+i).className  = "datamodified";
        }
      }
      document.getElementById(CanID+'-'+i).innerHTML = Value;
    }
    document.getElementById(CanID + '-Time').innerHTML = TimeStamp;
  } catch (e){
    var DataWindow = document.getElementById('DataWindow');

    var RowDiv = document.createElement('tr');
    RowDiv.setAttribute('class', 'row');

    var CanIDDiv = document.createElement('td');
    CanIDDiv.setAttribute('id', CanID);
    CanIDDiv.setAttribute('class', 'canid');
    RowDiv.appendChild(CanIDDiv);

    for (var j=0; j<8; j++){
      var NewDiv = document.createElement('td');
      NewDiv.setAttribute('id', CanID+'-'+j);
      NewDiv.setAttribute('class', 'data');
      RowDiv.appendChild(NewDiv);
    }

    var TimeDiv = document.createElement('td');
    TimeDiv.setAttribute('id', CanID+'-Time');
    TimeDiv.setAttribute('class', 'timestamp');
    RowDiv.appendChild(TimeDiv);

    DataWindow.appendChild(RowDiv);
    //alert(CanID+Data+TimeStamp);
    document.getElementById(CanID).innerHTML = CanID;
  }
}

function processSD(){
  if(SDRequest.readyState == 4){
    if(SDRequest.status == 200){
      try {
        //Get the root node
        var xml = SDRequest.responseXML.getElementsByTagName('CanPackets')[0];
        //Get the subnodes
        var PacketNodes = xml.getElementsByTagName("CanPacket");
      } catch (e){
        return false;
      }

      var CanID = "";
      var Data = "";
      for(var iPacket=0; iPacket<PacketNodes.length; iPacket++){
        CanID = PacketNodes[iPacket].attributes.getNamedItem("CanID").value;
        Data = PacketNodes[iPacket].attributes.getNamedItem("Data").value;
        TimeStamp = PacketNodes[iPacket].attributes.getNamedItem("TimeStamp").value;
        drawsniffdata(CanID, Data, TimeStamp);
      }
    }
  }
}

function GetXMLHttpObject()
{
  var xmlHttp=null;
  try {
    //New Browsers, Firefox, Safari, IE7
    xmlHttp=new XMLHttpRequest();
  } catch (e) {
    // Old IE
    try{
      xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
  }
  return xmlHttp;
}
